/*
 *  bfConv.cpp
 *  fp
 *
 *  Created by Robert Delaney on 4/13/13.
 *  Copyright 2013 __Bob Delaney's Science Software_.. All rights reserved.
 *
 */


#include "bf.h"
#include "bfConv.h"

/*
 finds greatest common divisor of x,y and divides it out
 */
static void reduce(mb& x, mb& y)
{
	mb	factor;
	
	//if(x==0 || y==0)
	//	return;
	
	factor = gcd(abs(x), y);
	
	x = x/factor;
	y = y/factor;
	
}/* reduce */

using namespace std;

bool bfConvFromStr(bf& z, const char *bfStr)
{
	int		i, iSave, length;
	char	ch, *tempStr;
	
	length = strlen(bfStr);
	if(!length)
		return false;
	
	if(bfStr[0]=='/')
		return false;
	
	tempStr = (char*)malloc((length+1)*sizeof(char));
	
	
	for(i=0;i<=length;i++)
	{
		iSave = i;
		ch = bfStr[i];
		if(ch=='/')
		{
			tempStr[i] = 0;
			if(!mbConvFromStr(z.num, tempStr))
				goto isFalse;
			break;
		}
		else
			tempStr[i] = ch;
	}
	
	if(iSave==length)
	{
		if(!mbConvFromStr(z.num, tempStr))
			goto isFalse;
		z.den = 1;
		free(tempStr);
		return true;
	}
	
	// now iSave points to '/'
	for(i=iSave+1;i<=length;i++)
		tempStr[i-iSave-1] = bfStr[i];
	
	if(strlen(tempStr)==0)
		goto isFalse;
	
	if(!mbConvFromStr(z.den, tempStr))
		goto isFalse;
	
	if(!z.den.n)
		goto isFalse;
	
	reduce(z.num, z.den);
	
	if(z.den.n<0)
	{
		z.num = -z.num;
		z.den = -z.den;
	}
	
	free(tempStr);
	return true;
	
isFalse:
	z.num = 0;
	z.den = 1;
	free(tempStr);
	return false;
	
}/* bfConvFromStr */


void bfConvToStr(char*& bfStr, const bf& x)
{
	char		*numStr, *denStr;
	int			numLen, denLen;
	
	equate(numStr, x.num);
	numLen = strlen(numStr);
	if(x.den==1)
	{
		bfStr = (char*)malloc((numLen+1)*sizeof(char));
		strcpy(bfStr, numStr);
		free(numStr);
		return;
	}
	
	equate(denStr, x.den);
	denLen = strlen(denStr);
	
	bfStr = (char*)malloc((numLen+denLen+2)*sizeof(char));
	
	strcpy(bfStr, numStr);
	strcat(bfStr,"/");
	strcat(bfStr,denStr);
	
	free(numStr);
	free(denStr);

}/* bfConvToStr */

void equate(fp& z, const bf& x)
{
	fp		fpNum, fpDen;
	
	fpNum = x.num;
	fpDen = x.den;
	
	z = fpNum / fpDen;
	
}/* equate */

